{*******************************************************}
{                                                       }
{         Delphi eXtensions Expert(X)                   }
{                                                       }
{         Copyright (c) 1997 Buzaev Alexander           }
{         Manager eXtension Expert                      }
{*******************************************************}

unit MgrExp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FindExp, ExptIntf, ToolIntf, Menus, RenExp, MNavExp, FldExp, // Helps,
  xAbout, ComExp;

type
  TMgrExpDlg = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
  private
  public
  end;

Type
  ManagerExpert = class(TIExpert)
  private
    ExpertsItem, MNavItem: TIMenuItemIntf;
    FldItem, RenamerItem: TIMenuItemIntf;
    FFilesItem, PackagesItem, FindItem: TIMenuItemIntf;
    HelpsItem: TIMenuItemIntf;
    SepItem, AboutItem: TIMenuItemIntf;
    procedure FindItemClick(Sender: TIMenuItemIntf);
    procedure PackagesItemClick(Sender: TIMenuItemIntf);
    procedure FFavorItemClick(Sender: TIMenuItemIntf);
    procedure MNavItemClick(Sender: TIMenuItemIntf);
    procedure RenamerItemClick(Sender: TIMenuItemIntf);
    procedure FldItemClick(Sender: TIMenuItemIntf);
    procedure HelpsItemClick(Sender: TIMenuItemIntf);
    procedure AboutItemClick(Sender: TIMenuItemIntf);
    procedure CreateMenu;
  public
    constructor Create;
    destructor Destroy; override;

    function GetAuthor: string; override;
    function GetPage: string; override;
    function GetStyle: TExpertStyle; override;
    function GetIDString: string; override;
    function GetName: string; override;
    function GetComment: string; override;
    function GetGlyph: HBITMAP; override;
    function GetState: TExpertState; override;
    function GetMenuText: string; override;
    procedure Execute; override;
  end;

procedure Register;

var
  MgrExpDlg: TMgrExpDlg;

implementation

{$R *.DFM}

procedure Register;
begin
  RegisterLibraryExpert(ManagerExpert.Create);
end;

constructor ManagerExpert.Create;
Begin
  inherited;
  MgrExpDlg:=Nil; FindExpDlg:=Nil;
//  HelpDlg := Nil;
  CreateMenu;
End;

procedure ManagerExpert.CreateMenu;
var
  MainMenu: TIMainMenuIntf;
  ToolsMenu: TIMenuItemIntf;
//  i: Integer;
Begin
  ToolsMenu:=Nil;
  MainMenu:=ToolServices.GetMainMenu;
  IF MainMenu<>nil Then
  begin
    //Define Name MainMenu
    {
    DON'T ERASE !!!
    ToolsMenu:=MainMenu.GetMenuItems;
    For i:=0 To ToolsMenu.GetItemCount-1 Do
    begin
      ShowMessage((ToolsMenu.GetItem(i) as TIMenuItemIntf).GetName);
    end;}
//    ToolsMenu := MainMenu.FindMenuItem('ViewsMenu');
    ToolsMenu:=MainMenu.GetMenuItems;
    IF ToolsMenu <> nil Then
    begin
      ExpertsItem:=ToolsMenu.InsertItem(ToolsMenu.GetItemCount-1,
        'X', 'ExpertsItem', '', 0, 0, 0, [mfVisible, mfEnabled], Nil);
      FindItem:=ExpertsItem.InsertItem(ExpertsItem.GetItemCount,
        'Find Source', 'FindItem', '', TextToShortCut('Alt+Enter'),
        0, 0, [mfVisible, mfEnabled], FindItemClick);
      FFilesItem:=ExpertsItem.InsertItem(ExpertsItem.GetItemCount,
        'Favofites', 'FFavorItem', '', TextToShortCut('Alt+F'),
        0, 0, [mfVisible, mfEnabled], FFavorItemClick);
      PackagesItem:=ExpertsItem.InsertItem(ExpertsItem.GetItemCount,
        'Packages', 'PackagesItem', '', TextToShortCut('Alt+P'),
        0, 0, [mfVisible, mfEnabled], PackagesItemClick);
      RenamerItem:=ExpertsItem.InsertItem(ExpertsItem.GetItemCount,
        'Component Renamer', 'RenamerItem', '', TextToShortCut('Alt+R'),
        0, 0, [mfVisible, mfEnabled], RenamerItemClick);
      FldItem:=ExpertsItem.InsertItem(ExpertsItem.GetItemCount,
        'Field Expert', 'FldItem', '', 0,
        0, 0, [mfVisible, mfEnabled], FldItemClick);
      MNavItem:=ExpertsItem.InsertItem(ExpertsItem.GetItemCount,
        'Metod Navigator', 'MNavItem', '', TextToShortCut('Alt+M'),
        0, 0, [mfVisible, mfEnabled], MNavItemClick);
{      HelpsItem := ExpertsItem.InsertItem(ExpertsItem.GetItemCount,
        'Additional Helps', 'HelpsItem', '', TextToShortCut('Alt+F1'),
        0, 0, [mfVisible, mfEnabled], HelpsItemClick);}
      SepItem:=ExpertsItem.InsertItem(ExpertsItem.GetItemCount,
        '-', 'SepItem', '', 0, 0, 0, [mfVisible, mfEnabled], Nil);
      AboutItem:=ExpertsItem.InsertItem(ExpertsItem.GetItemCount,
        '&About...', 'AboutItem', '', 0,
        0, 0, [mfVisible, mfEnabled], AboutItemClick);
    end;
  end;
  ToolsMenu.Free;
  MainMenu.Free;
End;

destructor ManagerExpert.Destroy;
Begin
  //Menu Items
  MNavItem.Free;
  RenamerItem.Free; FldItem.Free;
  FindItem.Free; FFilesItem.Free; PackagesItem.Free;
  ExpertsItem.Free;
  //Dialogs
  MNavExpDlg.Free;
  MgrExpDlg.Free; FindExpDlg.Free;
  HelpsItem.Free;
  inherited;
End;

function ManagerExpert.GetAuthor: string;
Begin
  Result:='';
End;
function ManagerExpert.GetPage: string;
Begin
  Result:='';
End;
function ManagerExpert.GetStyle: TExpertStyle;
begin
  Result:=esAddIn;
end;
function ManagerExpert.GetIDString: String;
begin
  Result:='Alexander Buzaev.Manager Expert';
end;
function ManagerExpert.GetComment: String;
begin
  Result:='';
end;
function ManagerExpert.GetGlyph: HBITMAP;
begin
  Result:=0;
end;
function ManagerExpert.GetName: String;
begin
  Result:='Manager Expert';
end;
function ManagerExpert.GetState: TExpertState;
begin
  Result := [esEnabled]
end;
function ManagerExpert.GetMenuText: String;
begin
  Result:='Manager Find Expert';
end;
procedure ManagerExpert.Execute;
begin
{  IF MgrExpDlg=Nil then
    MgrExpDlg:=TMgrExpDlg.Create(Nil);
  MgrExpDlg.ShowModal;}
end;

procedure ManagerExpert.FindItemClick(Sender: TIMenuItemIntf);
Begin
  ExecuteFindExp(ptFiles);
End;

procedure ManagerExpert.PackagesItemClick(Sender: TIMenuItemIntf);
Begin
  ExecuteFindExp(ptPackages);
End;

procedure ManagerExpert.FFavorItemClick(Sender: TIMenuItemIntf);
Begin
  ExecuteFindExp(ptFFavor);
End;

procedure ManagerExpert.MNavItemClick(Sender: TIMenuItemIntf);
Begin
  ExecuteMNav;
End;

procedure ManagerExpert.RenamerItemClick(Sender: TIMenuItemIntf);
Begin
  ExecuteRenamer;
End;

procedure ManagerExpert.FldItemClick(Sender: TIMenuItemIntf);
Begin
  ExecuteFldExp;
End;

procedure ManagerExpert.HelpsItemClick(Sender: TIMenuItemIntf);
Begin
//  ExecuteHelps;
End;

procedure ManagerExpert.AboutItemClick(Sender: TIMenuItemIntf);
var
  AboutRec: TAboutRec;
Begin
  AboutRec.Version:=xVersion;
  AboutRec.Author:=xAuthor;
  ExecAboutDlg(AboutRec);
End;

procedure TMgrExpDlg.FormCreate(Sender: TObject);
begin
//  ExecuteFindExp(ptFiles);
//  ExecuteMNav;
end;

procedure TMgrExpDlg.FormDblClick(Sender: TObject);
begin
  ExecuteFindExp(ptFiles);
end;

end.
